/***********************************************************************
 * 
 * Individual module for the cc65 compiler.
 *
 * The template for this file was created by TempC Module Creator by
 * Joseph Rose.  This template can be used in your programs, provided
 * you mention TempC in your software's documentation.  If this source
 * code is distributed, this copyright must be included in the file.
 *
 ***********************************************************************/

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <conio.h>
#include <plus4.h>

#include "simpleio.h"

#include "madlib64.h"

//char* __fastcall__ hstrchr(void* s, char t);

void getmod (char* m)
{
	//curpos: pos. in output,
	//mpos: pos. in input,
	unsigned curpos=0, mpos=0, i, j;
	char c;		//Current char.
	//ftype: string containing the type of text to fill in,
	//ftext: substitute text input from user,
	//curmptr: pointer to current loc. in input.
	char ftype[32], ftext[32], *curmptr;
	//Read current byte and exit if EOS.
	while (c=*(curmptr=&m[mpos])) {
		//% character?
		if (c=='%') {
			//Output % if directly followed by another %.
			if ((curmptr[1])=='%')
			{curmod[curpos++]='%'; mpos+=2; continue;}
			//Otherwise, get the word between < and >
			//(Assumes % is followed by < and skips <)
			i=strchr(curmptr+1, '>')-curmptr;
			//and store as prompt.
			memcpy (ftype, curmptr+2, i-1);
			ftype[i-2]=0;
			//Prompt user.
			prints (ftype); prints (": ");
			j=GetInput (ftext, 32);
			//getline(ftext);
			//Fill in substitute word(s) and advance.
			strcpy (&curmod[curpos], ftext);
			curpos+=j-1;
			//curpos+=strlen(ftext)-1;
			mpos+=i+1;
			//printcr();
		} else {
			//If regular char., simply write and advance.
			curmod[curpos++]=c; ++mpos;
		}
	}
	//Set EOS for output.
	curmod[curpos]=0;
}

